/*  Copyright (C) 2008 Josh Ventura
 *
 *  This file is a part of CLutterBuddy
 *
 *  CLutterBuddy is free software: you can redistribute it and/or modify it under the
 *  terms of the GNU General Public License as published by the Free Software
 *  Foundation, version 3 of the license or any later version.
 *
 *  This application and its source code is distributed AS-IS, WITHOUT ANY
 *  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 *  FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 *  details.
 *
 *  You should have recieved a copy of the GNU General Public License along
 *  with this code. If not, see <http://www.gnu.org/licenses/>
 */

#include <windows.h>
#include <string>
#include <map>

#include <windowsx.h>

using namespace std;


HWND mywindow,desktop;
HWND input,button_find,winlist,button_hide,window_in_question=NULL;
HWND button_show,button_flash,button_minim,button_nttop,button_maxim,button_topms,button_showall,
     button_childx,button_totop,button_inq,button_child,button_hideall,button_showALL,button_del,
     button_restr,button_unhl,button_close,button_mouse,button_about;
map<int,HWND> hiddenwindows; int hwcount=0;


LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);

char szClassName[] = "ClutterBuddy";



int asleep=0;




bool found=0;
string findstr;
HWND handlefound;
string captionfound;

BOOL foreachwindow(HWND handle,LPARAM casesens)
{
  char writehere[1025];
  GetWindowText(handle,writehere,1024);
  string castr=writehere;
  
  if (!casesens) for (int i=0;i<castr.length();i++) if (castr[i]>='A' && castr[i]<='Z') castr[i]-='A'-'a';
  
  if (castr.find(findstr,0)==string::npos)
  {
    return 1;
  }
  else 
  {
    handlefound=handle;
    captionfound=writehere;
    found=1;
    return 0;
  }
}
BOOL foreachclass(HWND handle,LPARAM casesens)
{
  char writehere[1025];
  GetClassName(handle,writehere,1024);
  string castr=writehere;
  
  if (!casesens) for (int i=0;i<castr.length();i++) if (castr[i]>='A' && castr[i]<='Z') castr[i]-='A'-'a';
  
  if (castr.find(findstr,0)==string::npos)
  {
    return 1;
  }
  else 
  {
    handlefound=handle;
    captionfound="#"; captionfound+=writehere;
    found=1;
    return 0;
  }
}
BOOL windowmouse(HWND handle,LPARAM casesens)
{
  RECT window;
  GetWindowRect(handle,&window);
  POINT mouse;
  GetCursorPos(&mouse);
    	
  if((mouse.x<window.left   ||
      mouse.y<window.top    ||
      mouse.x>window.right  ||
      mouse.y>window.bottom  )
                            ||
     !IsWindowVisible(handle))
  {
    return 1;
  }
  else 
  {
    handlefound=handle;
    
    char writehere[1025];
    GetWindowText(handle,writehere,1024);
    
    captionfound=writehere;
    found=1;
    return 0;
  }
}
bool findwindow(string caption,bool casesens)
{
  found=0;
  findstr=caption;
  if (findstr=="#at mouse")
  {
    //MessageBox(NULL,"With this window in focus, place your mouse over the desired window and press enter.","Instructions",MB_OK);
    //EnumWindows((WNDENUMPROC)windowmouse,0);
    while (GetForegroundWindow()==mywindow) Sleep(50);
    handlefound=GetForegroundWindow();
    
    char writehere[1025];
    GetWindowText(handlefound,writehere,1024);
    
    captionfound=writehere;
    SetWindowPos(mywindow,HWND_TOP,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE);
    return 1;
  }
  else
  {
     if (findstr[0]!='#')
     EnumWindows((WNDENUMPROC)foreachwindow,casesens);
     else
     {
        findstr.erase(0,1);
        EnumWindows((WNDENUMPROC)foreachclass,casesens);
     }
  }
  return found;
}


BOOL showit(HWND handle,LPARAM p)
{ ShowWindow(handle,p); return 1; }

void ShowAllWindows()
{
  EnumWindows((WNDENUMPROC)showit,SW_SHOW);
}





bool addlistitem(HWND handle,LPARAM lparam)
{
  if (IsWindowVisible(handle))
  {
    handlefound=handle;
    
    char writehere[1025];
    GetWindowText(handle,writehere,1024);
    if (writehere[0]==0) { GetClassName(handle,writehere+1,1023); writehere[0]='#'; }
    
    ComboBox_AddString(input,writehere);
  }
  return 1;
}


void addtolist(HWND handle,string cap)
{
  int on=0;
  for (int i=0;i<hwcount;i++) 
  if (hiddenwindows[i]==handle) 
  { on=1; break; }
  if (!on)
  {
    ListBox_AddString(winlist,cap.c_str());
    hiddenwindows[hwcount++]=handle; 
  }
}



void removeifromlist(int i)
{
    ListBox_DeleteString(winlist,i);
    hiddenwindows.erase(i);
    hwcount--;
    for (int ii=i;ii<hwcount;ii++) 
    hiddenwindows[ii]=hiddenwindows[ii+1];
}
void removefromlist(HWND handle)
{
  for (int i=hwcount-1;i>=0;i--)
  if (hiddenwindows[i]==handle)
  {
    removeifromlist(i);
  }
}






string captiontodo() 
{
  char retstr[1025];
  GetWindowText(input,retstr,1024);
  return retstr;
}




void hidewindow(HWND handle,string caption)
{
   if (ShowWindow(handle,SW_HIDE)) 
   {
      if (caption=="")
      {
        char writehere[1025];
        GetClassName(handle,writehere,1024);
        caption="#"; caption+=writehere;
      }
      addtolist(handle,caption); 
   }
}

bool foreachhide(HWND handle,LPARAM lpar)
{
   if (handle==mywindow) return 1;
   
   char writehere[1025]; string castr;
   GetClassName(handle,writehere,1024);
   castr=writehere;
   
   if (castr=="Shell_TrayWnd" || castr=="Progman") return 1;
   
   GetWindowText(handle,writehere,1024);
   castr=writehere;
   
   if (IsWindowVisible(handle))
   hidewindow(handle,castr);
   return 1;
}

void hideallwindows()
{
  EnumWindows((WNDENUMPROC)foreachhide,0);
}



BOOL showitlist(HWND handle,LPARAM p)
{ ShowWindow(handle,SW_SHOW); removefromlist(handle);  return 1; }

void showchildren(HWND handle)
{
  EnumChildWindows(handle,(WNDENUMPROC)showitlist,SW_SHOW);
  ShowOwnedPopups(handle,1);
}

void hidechildren(HWND handle)
{
  EnumChildWindows(handle,(WNDENUMPROC)foreachhide,0);
  ShowOwnedPopups(handle,0);
}






void step()
{
  int gcs=ComboBox_GetCurSel(input);
  if (gcs>=0)
  {
    string capsnd=captiontodo();
    for (int i=0;i<capsnd.length();i++) if (capsnd[i]>='A' && capsnd[i]<='Z') capsnd[i]-='A'-'a';
    if (findwindow(capsnd,0))
    {
      SetWindowText(input,captionfound.c_str());
      window_in_question=handlefound;
    } else SetWindowText(input,"Invalid window handle.");
  }
  
  if (!ComboBox_GetDroppedState(input))
  {
    string capsnd=captiontodo();
    for (int i=ComboBox_GetCount(input);i>=0;i--)
    ComboBox_DeleteString(input,i);
    EnumWindows((WNDENUMPROC)addlistitem,0);
    if (captiontodo()=="")
    SetWindowText(input,capsnd.c_str());
  }
  
  if (SendMessage(button_find,BM_GETSTATE,0,0)==108)
  {
    string capsnd=captiontodo();
    for (int i=0;i<capsnd.length();i++) if (capsnd[i]>='A' && capsnd[i]<='Z') capsnd[i]-='A'-'a';
    if (findwindow(capsnd,0))
    {
      SetWindowText(input,captionfound.c_str());
      window_in_question=handlefound;
    }
    else
    {
      if (capsnd[0]!='#')
      MessageBox(mywindow,"Text does not match any window caption. Check your spelling, perhaps.","Sorry",MB_OK);
      else
      MessageBox(mywindow,"Text does not match any window caption. Check your spelling.\r\n\r\nAlso be aware that prepending a '#' denotes a window class, not caption.","Sorry",MB_OK);
    }
  }
  if (SendMessage(button_mouse,BM_GETSTATE,0,0)==108)
  {
    if (findwindow("#at mouse",0))
    {
      SetWindowText(input,captionfound.c_str());
      window_in_question=handlefound;
    }
    else MessageBox(mywindow,"Text does not match any window caption. Check your spelling, perhaps.","Sorry",MB_OK);
  }
  
  
  if (SendMessage(button_hide,BM_GETSTATE,0,0)==108)
      { hidewindow(window_in_question,captionfound); }
  if (SendMessage(button_show,BM_GETSTATE,0,0)==108)
      { ShowWindow(window_in_question,SW_SHOW); 
        removefromlist(window_in_question); }
  
  if (SendMessage(button_flash,BM_GETSTATE,0,0)==108)
      { FlashWindow(window_in_question,1); }
  if (SendMessage(button_child,BM_GETSTATE,0,0)==108)
      { showchildren(window_in_question); }
  if (SendMessage(button_childx,BM_GETSTATE,0,0)==108)
      { hidechildren(window_in_question); }
  
  if (SendMessage(button_topms,BM_GETSTATE,0,0)==108)
      { SetWindowPos(window_in_question,HWND_TOPMOST,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE); }
  if (SendMessage(button_totop,BM_GETSTATE,0,0)==108)
      { SetWindowPos(window_in_question,HWND_TOP,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE); }
  if (SendMessage(button_nttop,BM_GETSTATE,0,0)==108)
      { SetWindowPos(window_in_question,HWND_BOTTOM,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE|SWP_NOACTIVATE); }
  
  if (SendMessage(button_minim,BM_GETSTATE,0,0)==108)
      { ShowWindow(window_in_question,SW_MINIMIZE); }
  if (SendMessage(button_maxim,BM_GETSTATE,0,0)==108)
      { ShowWindow(window_in_question,SW_MAXIMIZE); }
  if (SendMessage(button_restr,BM_GETSTATE,0,0)==108)
      { ShowWindow(window_in_question,SW_RESTORE); }
  
  
  if (SendMessage(button_showall,BM_GETSTATE,0,0)==108)
      { for (int i=0;i<hwcount;i++) 
      { ShowWindow(hiddenwindows[i],SW_SHOW); ListBox_DeleteString(winlist,0); }
        hiddenwindows.clear(); hwcount=0; }
  if (SendMessage(button_showALL,BM_GETSTATE,0,0)==108)
      { if (MessageBox(mywindow,"That's a stupid idea. Continue?","Click no",MB_YESNO)==IDYES) ShowAllWindows(); }
  if (SendMessage(button_hideall,BM_GETSTATE,0,0)==108)
      { hideallwindows(); }
      
  
  
  if (SendMessage(button_close,BM_GETSTATE,0,0)==108)
      { asleep=1; ShowWindow(mywindow,SW_HIDE); }
  
  if (SendMessage(button_inq,BM_GETSTATE,0,0)==108)
      {                                       
        for (int i=0;i<hwcount;i++)
        if (ListBox_GetSel(winlist,i))
        {
          window_in_question=hiddenwindows[i];
          char writehere[1025];
          ListBox_GetText(winlist,i,writehere);
          captionfound=writehere;
          SetWindowText(input,writehere);
          break;
        }
      }
  if (SendMessage(button_del,BM_GETSTATE,0,0)==108)
      { if (ListBox_GetSelCount(winlist)>0)
        if (MessageBox(mywindow,"Remove watch on selected window(s)? You will not be able to restore them if you forget their caption.","Click no",MB_YESNO)==IDYES) 
        for (int i=hwcount-1;i>=0;i--)
        if (ListBox_GetSel(winlist,i))
        {
          removeifromlist(i);
        }
      }
  if (SendMessage(button_unhl,BM_GETSTATE,0,0)==108)
      { for (int i=hwcount-1;i>=0;i--)
        if (ListBox_GetSel(winlist,i))
        {
          ShowWindow(hiddenwindows[i],SW_SHOW);
          removeifromlist(i);
        }
      }
      
  if (SendMessage(button_about,BM_GETSTATE,0,0)==108)
      { MessageBox(mywindow,"CLutterBuddy v1.0a\r\n\r\nA powerful window tool.\r\nCopyright (C) 2008 Josh Ventura\r\nNo help is available at this time: Just experiment. It's relatively easy to figure out.","About",MB_OK); }
  
  if (!IsWindowVisible(mywindow))
    asleep=1;
}












void hibernate()
{
   Sleep(250);
}













int giveup=0;
BOOL cbrunning(HWND handle,LPARAM nothing)
{
  char writehere[1025];
  GetClassName(handle,writehere,1024);
  string castr=writehere;
  
  if (castr==szClassName)
  {
    SendMessage(handle,1337,1249,0);
    giveup=1;
    return 0;
  }
  return 1;
}


int WINAPI WinMain (HINSTANCE hThisInstance,HINSTANCE hPrevInstance,LPSTR lpszArgument,int nFunsterStil)
{
    desktop=GetDesktopWindow();
    MSG messages;
    
    
    giveup=0;
    EnumWindows((WNDENUMPROC)cbrunning,0);
    if (giveup) return 0;
    
    
    WNDCLASSEX mywindowclass;
    
    mywindowclass.hInstance = hThisInstance;
    mywindowclass.lpszClassName = szClassName;
    mywindowclass.lpfnWndProc = WindowProcedure;
    mywindowclass.style = CS_DBLCLKS;
    mywindowclass.cbSize = sizeof (WNDCLASSEX);
    
    mywindowclass.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    mywindowclass.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    mywindowclass.hCursor = LoadCursor (NULL, IDC_ARROW);
    mywindowclass.lpszMenuName = NULL;
    mywindowclass.cbClsExtra = 0;
    mywindowclass.cbWndExtra = 0;
    
    mywindowclass.hbrBackground = (HBRUSH) COLOR_BACKGROUND;
    
    if (!RegisterClassEx (&mywindowclass))
        return 0;
    
    mywindow = CreateWindow(szClassName,"CLutterBuddy",WS_MINIMIZEBOX | WS_CAPTION | WS_SYSMENU,CW_USEDEFAULT,CW_USEDEFAULT,
    544,412,HWND_DESKTOP,NULL, hThisInstance,NULL);
    
    input = CreateWindow ("COMBOBOX","",WS_VISIBLE | WS_CHILD | CBS_DROPDOWN,8,8,420,480,mywindow,0,hThisInstance,0);
    
    button_find = CreateWindow ("BUTTON","Find", WS_VISIBLE | WS_CHILD,434,8,40,24,mywindow,0,hThisInstance,0);
    button_mouse = CreateWindow("BUTTON","Mouse",WS_VISIBLE | WS_CHILD,478,8,50,24,mywindow,0,hThisInstance,0);
    
    button_hide = CreateWindow ("BUTTON","Hide Window", WS_VISIBLE | WS_CHILD,8,40,96,28,mywindow,0,hThisInstance,0);
    button_show = CreateWindow ("BUTTON","Show Window", WS_VISIBLE | WS_CHILD,8,72,96,28,mywindow,0,hThisInstance,0);
    
    button_flash = CreateWindow ("BUTTON","Flash Window", WS_VISIBLE | WS_CHILD,108,40,96,20,mywindow,0,hThisInstance,0);
    button_child = CreateWindow ("BUTTON","Show Children",WS_VISIBLE | WS_CHILD,204,40,96,20,mywindow,0,hThisInstance,0);
    button_childx= CreateWindow ("BUTTON","Hide Children",WS_VISIBLE | WS_CHILD,300,40,96,20,mywindow,0,hThisInstance,0);
    
    button_topms = CreateWindow ("BUTTON","Stay on Top", WS_VISIBLE | WS_CHILD,108,60,96,20,mywindow,0,hThisInstance,0);
    button_totop = CreateWindow ("BUTTON","Send to Top", WS_VISIBLE | WS_CHILD,204,60,96,20,mywindow,0,hThisInstance,0);
    button_nttop = CreateWindow ("BUTTON","Send to Back",WS_VISIBLE | WS_CHILD,300,60,96,20,mywindow,0,hThisInstance,0);
    
    button_minim = CreateWindow ("BUTTON","Minimize it",WS_VISIBLE | WS_CHILD,108,80,96,20,mywindow,0,hThisInstance,0);
    button_maxim = CreateWindow ("BUTTON","Maximize it",WS_VISIBLE | WS_CHILD,204,80,96,20,mywindow,0,hThisInstance,0);
    button_restr = CreateWindow ("BUTTON","Restore it", WS_VISIBLE | WS_CHILD,300,80,96,20,mywindow,0,hThisInstance,0);
    
    button_showALL = CreateWindow ("BUTTON","+ALL",WS_VISIBLE | WS_CHILD,496,40,32,30,mywindow,0,hThisInstance,0);
    button_hideall = CreateWindow ("BUTTON","Hide all",WS_VISIBLE | WS_CHILD,432,40,64,30,mywindow,0,hThisInstance,0);
    button_showall = CreateWindow ("BUTTON","Unhide All",WS_VISIBLE | WS_CHILD,432,70,96,30,mywindow,0,hThisInstance,0);
    
    winlist = CreateWindow ("LISTBOX","",WS_VISIBLE | WS_VSCROLL | WS_CHILD | LBS_EXTENDEDSEL | LBS_DISABLENOSCROLL,8,112,480,256,mywindow,0,hThisInstance,0);
    button_inq = CreateWindow ("BUTTON","^",WS_VISIBLE | WS_CHILD,496,112,32,30,mywindow,0,hThisInstance,0);
    button_del = CreateWindow ("BUTTON","X",WS_VISIBLE | WS_CHILD,496,152,32,20,mywindow,0,hThisInstance,0);
    button_unhl = CreateWindow ("BUTTON","=>",WS_VISIBLE | WS_CHILD,496,182,32,20,mywindow,0,hThisInstance,0);
    
    button_about = CreateWindow ("BUTTON","[A]",WS_VISIBLE | WS_CHILD,496,322,32,20,mywindow,0,hThisInstance,0);
    button_close = CreateWindow ("BUTTON","[V]",WS_VISIBLE | WS_CHILD,496,346,32,20,mywindow,0,hThisInstance,0);
    
    ShowWindow (mywindow, SW_SHOW);
    
    
    
    
    
    
    
    
    
    
    /* Run the message loop. It will run until GetMessage() returns 0 */
    while (GetMessage (&messages, NULL, 0, 0))
    {
        if (!asleep) { step(); Sleep(1);  }
        else hibernate();
        
        /* Translate virtual-key messages into character messages */
        TranslateMessage(&messages);
        /* Send message to WindowProcedure */
        DispatchMessage(&messages);
    }

    /* The program return-value is 0 - The value that PostQuitMessage() gave */
    return messages.wParam;
}


/*  This function is called by the Windows function DispatchMessage()  */

LRESULT CALLBACK WindowProcedure (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message)                  /* handle the messages */
    {
        case WM_CLOSE:
             if (hwcount==0 || MessageBox(mywindow,"Close CLutterBuddy?","Confirm",MB_YESNO)==IDYES) 
             PostQuitMessage(0);
             break;
        case 1337:
             if (wParam==1249)
             {
             ShowWindow(mywindow,SW_SHOW);
             asleep=0;
             FlashWindow(mywindow,1);
             break;
             }
        case WM_DESTROY:
            PostQuitMessage (0);
            break;
        default:
            return DefWindowProc (hwnd, message, wParam, lParam);
    }

    return 0;
}
